package com.xxfc.rv.call;

import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.util.Log;

import de.greenrobot.event.EventBus;
import de.greenrobot.event.Subscribe;
import de.greenrobot.event.ThreadMode;

/**
 * Audio Video Call Meet Controller
 */
public class AudioOrVideoController {
    private static AudioOrVideoController instance;
    private Context mContext;

    private AudioOrVideoController(Context context) {
        this.mContext = context;
        EventBus.getDefault().register(this);
    }

    public static AudioOrVideoController init(Context context) {
        if (instance == null) {
            instance = new AudioOrVideoController(context);
        }
        return instance;
    }

    /**
     * 我方取消、挂断通话后发送XMPP消息给对方
     * <p>
     * 在断点调试禅道bug4503、4505时发现，本地居然存在了两个CoreManager，且该CoreManager内的对象都为空，导致取消、挂断的消息发送不出去
     * 暂无法查明出现两个CoreManager的原因，现将该 event事件 移至MainActivity内处理
     */
    /*@Subscribe(threadMode = ThreadMode.MainThread)
    public void helloEventBus(final MessageEventCancelOrHangUp event) {
        String mLoginUserId = mCoreManager.getSelf().getUserId();
        ChatMessage message = new ChatMessage();
        if (event.type == 103) {          // 取消 语音通话
            message.setType(XmppMessage.TYPE_NO_CONNECT_VOICE);
        } else if (event.type == 104) {// 取消 视频通话
            message.setType(XmppMessage.TYPE_END_CONNECT_VOICE);
        } else if (event.type == 113) {// 挂断 语音通话
            message.setType(XmppMessage.TYPE_NO_CONNECT_VIDEO);
        } else if (event.type == 114) {// 挂断 视频通话
            message.setType(XmppMessage.TYPE_END_CONNECT_VIDEO);
        }
        message.setMySend(true);
        message.setFromUserId(mLoginUserId);
        message.setFromUserName(mCoreManager.getSelf().getNickName());
        message.setToUserId(event.toUserId);
        message.setContent(event.content);
        message.setTimeLen(event.callTimeLen);
        message.setTimeSend(TimeUtils.sk_time_current_time());
        message.setPacketId(UUID.randomUUID().toString().replaceAll("-", ""));

        if (ChatMessageDao.getInstance().saveNewSingleChatMessage(mLoginUserId, event.toUserId, message)) {
            ListenerManager.getInstance().notifyNewMesssage(mLoginUserId, message.getFromUserId(), message, false);
        }

        mCoreManager.sendChatMessage(event.toUserId, message);
        MsgBroadcast.broadcastMsgUiUpdate(mContext);   // 更新消息界面

        *//*if (isSipback) {// 当app处于关闭状态收到来电，通话结束后终止程序
            ActivityStack.getInstance().exit();
            android.os.Process.killProcess(android.os.Process.myPid());
        }*//*
    }*/

    // 单聊 通话 来电
    @Subscribe(threadMode = ThreadMode.MainThread)
    public void helloEventBus(final MessageEventSipEVent messsage) {
        if (messsage.number == 100 || messsage.number == 110) {
            if (!JitsistateMachine.isInCalling) {
                Intent intent = new Intent(mContext, JitsiIncomingcall.class);
                if (messsage.number == 100) {
                    intent.putExtra(CallConstants.AUDIO_OR_VIDEO_OR_MEET, CallConstants.Audio);
                } else {
                    intent.putExtra(CallConstants.AUDIO_OR_VIDEO_OR_MEET, CallConstants.Video);
                }
                intent.putExtra("fromuserid", messsage.touserid);
                intent.putExtra("touserid", messsage.touserid);
                intent.putExtra("name", messsage.message.getFromUserName());
                if (!TextUtils.isEmpty(messsage.message.getFilePath())) {
                    intent.putExtra("meetUrl", messsage.message.getFilePath());
                }
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                mContext.startActivity(intent);
            }
        } else if (messsage.number == 103 || messsage.number == 113) {
            Log.e("AVI", "收到对方取消协议");
            if (messsage.message.getTimeLen() == 0) {
                EventBus.getDefault().post(new MessageHangUpPhone(messsage.message));
            }
        }
    }

    public void release() {
        EventBus.getDefault().unregister(this);
    }
}
