package com.xxfc.rv.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;

import com.j256.ormlite.android.apptools.OrmLiteSqliteOpenHelper;
import com.j256.ormlite.support.ConnectionSource;
import com.j256.ormlite.table.TableUtils;
import com.xxfc.rv.Constants;
import com.xxfc.rv.ImService;
import com.xxfc.rv.ImSetting;
import com.xxfc.rv.db.table.ChatMessage;
import com.xxfc.rv.db.table.CustomerService;

import java.sql.SQLException;


public class SQLiteHelper extends OrmLiteSqliteOpenHelper {

    public static final String DATABASE_NAME = "rv_im.db";
    private static final int DATABASE_VERSION = 1;

    public SQLiteHelper(Context context) {
        super(context, ImSetting.getUserId() + DATABASE_NAME, null, DATABASE_VERSION);
    }

    @Override
    public void onCreate(SQLiteDatabase db, ConnectionSource connSource) {
        createTables(connSource);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, ConnectionSource connSource, int oldVersion, int newVersion) {
    }

    private void createTables(ConnectionSource connSource) {
        try {
            TableUtils.createTableIfNotExists(connSource, ChatMessage.class);
            TableUtils.createTableIfNotExists(connSource, CustomerService.class);
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
